﻿VERSION = '1.01'
import sys
from Tkinter import *
from copy import deepcopy
import HTMLParser
import ttk
import win32clipboard
import   HtmlBBcodeParser 
from PIL import Image, ImageTk

class linkObj(object):
    def __init__(self,wiget,tag,link,size,italic,linkcommand,enterCalbak = None):
        self.w = wiget
        self.link = link
        self.tag = tag
        self.size = size
        #self.bigsize = int(size) + 3
        self.italic = italic
        self.linkcommand = linkcommand
        self.enterCalbak = enterCalbak
        
        
    def clik(self,*e):
        self.linkcommand(self.link)
        
    def enter(self,*e):
        if self.enterCalbak:
            self.enterCalbak(self.link)
        color = '#00CC66' if self.link.startswith('go://') else  '#00008B'
        self.w["cursor"] = 'hand2'
        self.w.tag_config(self.tag,
                        #font="Verdana %s bold %s"%(self.bigsize,self.italic),
                        foreground = color,
                        underline = 0)
         
    def leave(self,*e):
        color = '#336666' if self.link.startswith('go://') else 'blue'
        self.w["cursor"] = 'arrow' #  left_ptr    heart
        self.w.tag_config(self.tag,
                        font="Verdana %s normal %s"%(self.size,self.italic),
                        foreground = color,
                        underline = 1)

def copytext(text):
    try:
        texttowin = text #
        win32clipboard.OpenClipboard()
        win32clipboard.EmptyClipboard()
        win32clipboard.SetClipboardText(texttowin)
        win32clipboard.CloseClipboard()
    except TclError:
        pass
   

    
class PageWidget(Text):
    def __init__(self,master,enterCalbak = None,linkcommand = None,**kw):
        Text.__init__(self, master,**kw)
        self.master = master
       
        scrY = ttk.Scrollbar(master)
        scrY.config(command=self.yview)  
        scrX = ttk.Scrollbar(master,orient='horizontal')
        scrX.config(command=self.xview)                   
        self.config(yscrollcommand=scrY.set)
        self.config(xscrollcommand=scrX.set)
        scrY.pack(side='right',fill = "both",)
        self.pack(side='top',fill = "both",expand  = 1)
        scrX.pack(side='bottom',fill = "both",)  
        self['state'] = 'disabled'
        self.enterCalbak = enterCalbak
        self.linkcommand =  linkcommand 
        self.windowslabel = []
        
    def popupCreate(self,BackCommand = None,
                    NextCommand=None,
                    TranslCommand=None,
                    EditCommand = None):    
        self.popup = Menu(self.master, tearoff=0,font ="Verdana 10 bold" )
        self.popup.add_command(label="copy",foreground='red',
            command = lambda: copytext(self.selection_get()))
        self.popup.add_separator()
        self.popup.add_command(label="Back", command=BackCommand )
        self.popup.add_command(label="Next", command=NextCommand )
        self.popup.add_separator()
        self.popup.add_separator()
        self.popup.add_command(label="EdiT", command=EditCommand )
        self.popup.add_separator()
        self.popup.add_command(label="Translate", command=TranslCommand )
        
        self.bind("<ButtonRelease-3>", self.help_menu)
        
    def help_menu(self,event):
        try:
            try:
                self.selection_get()
                self.popup.entryconfig(0, state='normal')
                self.popup.entryconfig(8, state='normal')

                
            except TclError:
                self.popup.entryconfig(0, state='disabled')
                self.popup.entryconfig(8, state='disabled')

            
            
            
            self.popup.tk_popup(event.x_root, event.y_root, 0)
        finally:
            self.popup.grab_release()  

    def putBBCODE(self,text): 
        out = HtmlBBcodeParser.BBcode2MyData(text)
        self.putPage(out)
        '''import time
        
        y = x = time.time()
        html = HtmlBBcodeParser.BBcode2HTML(text)
        print '\nBBcode2HTML',time.time() -x
        x= time.time()
        out = HtmlBBcodeParser.HTML2MyData(html)
        print 'HTML2MyData',time.time() -x
        x= time.time()
        
        print 'putPage    ',time.time() -x
            
        print 'bbcode2page',time.time() -y'''    
            
    def putHtml(self,html): 
        mydata = HtmlBBcodeParser.HTML2MyData(html)
        self.putPage(mydata)
        
    def putPage(self,mydata):
        self['state'] = 'normal'
        self.delete(1.0,END)
        self.tag_delete(*self.tag_names())
        for x in self.windowslabel:
            print x,'destr'
            x.destroy()
        self.windowslabel = []    
        sbackground = '#F8F8F8'
        self['background'] = sbackground
        codebackground = '#F3E5C9'
        defsize = 12
        
        self.iss = []
        
        
        
        for number,elem in enumerate(mydata):
            tagName = "tag%s"%number
    
            background = elem.get('background',None)
            background = codebackground if  "#f8f8f8" == background else background
            #background = codebackground if 'background' in elem else None
            
            color = elem.get('color','black')
    
            size = elem.get('font-size',defsize)
            if str(size).endswith('px'): size = size[:-2]
            size = int(size)
            
            bold = elem.get('font-weight',0)
            if not bold:
                bold = "bold" if elem.get('strong',0) else  "normal"
                
            italic = "italic"  if elem.get('em',0) else  "roman" 
            
            underline =int(elem.get('u',0)) 

            overstrike = elem.get('strike',0)
    
            justify  = elem.get('text-align','left')
    
            link = elem.get('href',0)
            if link:
                color = '#336666' if link.startswith('go://') else 'blue'
                bold = "normal"
                underline = 1
                
                
            imagePath = elem.get('src',None)
                
                
            if imagePath:
                imagePath = self.path + imagePath
                try:
               
                    #self.iss.append(PhotoImage(file =imagePath))
                    self.iss.append(ImageTk.PhotoImage(Image.open(imagePath)))
                    labelIMGsbackground = sbackground
                    imgtext = ''
                except TclError, e:
                    self.iss.append(None)
                    imgtext = e
                    labelIMGsbackground = '#FF66CC'
                    print e
                except IOError, e:
                    self.iss.append(None)
                    imgtext = e
                    labelIMGsbackground = '#FF66CC'
                    print e    
                    
                    
                labelIMG = Label(self, text=imgtext,image=self.iss[-1], bg=labelIMGsbackground)
                self.windowslabel.append(labelIMG)
                #align= baseline, bottom, center, or top
                self.window_create(INSERT, window=labelIMG,)

                continue
            if 'p' in elem:
                size = int(size*1.5)

            self.tag_config(tagName,
                              foreground = color,
                              background = background ,
                              #bgstipple ="gray12", 
                              font="Verdana %s %s %s"%(size,bold,italic),
                              underline = underline,
                              overstrike = overstrike,
                              justify  = justify ,
                              lmargin1 = 5,
                              tabs     = 1,
                              ) 
                              
            if link:  
                l = linkObj(self,tagName,link,size,italic,self.linkcommand,enterCalbak = self.enterCalbak)
                self.tag_bind(tagName, "<Button-1>",l.clik)
                self.tag_bind(tagName, "<Enter>",l.enter)
                self.tag_bind(tagName, "<Leave>",l.leave)
            self.tag_lower(tagName)     
            self.insert(END,elem['text'],tagName)                  
        
        self['state'] = 'disabled'
        self["cursor"] = 'arrow' 
        
        
        
        
     
    
    
def _test(*e):    
   #      
   
    text = u"""
[GO]go[/GO] 
[url]utll[/url]
[code]3[/code]
[B]bbbb[/B]
[I]iiiii[/I]
[S]sssss[/S]
[U]uuuuu[/U]
[SIZE=20]7[/SIZE]
[COLOR="Red"]8[/COLOR]
[CENTER]9[/CENTER]
[IMG]img/pitch_yaw_roll.png[/IMG]
[H][/H]    
        """.replace('\n','\r\n').replace('[]','')       
    import pprint   
    #searchWorld = 'ext'
    #sword = searchWorld
    #newsword ='<div class="source" style="background:#00FFFF;color: #600000">%s</div>'%sword
    
    html = HtmlBBcodeParser.BBcode2HTML(text)
    #html = html.replace(sword,newsword)
    pprint.pprint(html)
    #out = HtmlBBcodeParser.HTML2MyData(html)   
    #out = HtmlBBcodeParser.BBcode2MyData(text)

    
    
    #
    
    t.putBBCODE(text)            
          

          
if __name__ == '__main__':       
        
    root = Tk()
    t = PageWidget(root, 
                font = 12,
                selectbackground ='#C8C8C8',
                borderwidth  = 3,
                #height  = 3,
                cursor = 'arrow',
                wrap = "none",
                linkcommand = _test)
                
                
    t.path = '\\'.join((sys.argv[0].split('\\')[0:-1]))+'\\'

   # t.

    t.popupCreate(BackCommand = _test,
                  NextCommand=_test,
                  EditCommand =_test)    
                
    import   HtmlBBcodeParser          
    
    
    _test()             
    root.mainloop()
            

      
    