﻿#!/usr/bin/python
# -*- encoding: utf-8 -*-
VERSION = '1.00'

import ttk
import sys
from Tkinter import *


class TreeWiget(ttk.Treeview):
    def __init__(self,master,**kw):
        ttk.Treeview.__init__(self, master,selectmode = 'browse',**kw)
       
        self.pageSelect = None
        self.master = master
        self.opens = 1
        self.searhModuleSelected = 'all'
        self.inside = 0
        self._curentpath = 0
        scrY = ttk.Scrollbar(master)
        scrY.config(command=self.yview)  
        scrX = ttk.Scrollbar(master,orient='horizontal')
        scrX.config(command=self.xview)                   
        self.config(yscrollcommand=scrY.set)
        self.config(xscrollcommand=scrX.set)
        scrY.pack(side='right',fill = "both",)
        self.pack(side='top',fill = "both",expand  = 1)
        self._found = 1
        self._entryfocused = 0
        

        self.entrySearch = Entry(master)  #ttk.
        self.searhModulevar = StringVar()
        frameSM = Frame(master)
        
        self.searhModule = ttk.Combobox(frameSM, textvariable=self.searhModulevar,)
        self.searhModule['state'] = 'readonly'
        self.searhModule.bind("<<ComboboxSelected>>", self.event_ComboboxSelected)
        self.check1var = IntVar()
        self.check1=Checkbutton(frameSM,text=u'inside',
                    variable=self.check1var, command=self.event_ComboboxSelected)
        self.searhModule.pack(side='left',)#fill = "both",
        self.check1.pack(side='right',fill = "both",)
        self.entrySearch.bind("<KeyRelease>", self.event_Entry_KeyRelease)
        
        def fin(*e):
            self._entryfocused = 1
            self._setcolorentry()
        def fout(*e):
            self._entryfocused = 0
            self._setcolorentry()
            
        self.entrySearch.config(background = '#E8E0FD')    
        self.entrySearch.bind("<FocusIn>",fin )
        self.entrySearch.bind("<FocusOut>",fout)
        
       # print dir(self.entrySearch)
        self.bind("<KeyRelease>", self.event_tree_KeyRelease)
        
        frameSM.pack(side='bottom',fill = "both")
        self.entrySearch.pack(side='bottom',fill = "both",)

        scrX.pack(side='bottom',fill = "both",)
        #self.popupCreate()
        
        def callback(kk = 1,*w):
            if kk == 1:
                kk=self.navig
                self.opens = not self.opens
            for x in kk:
                self.item(x['id'], open=self.opens)
                callback(x['child'])

        self.heading('#0',command= callback)
        
        self.bind('<<TreeviewSelect>>', self.event_TreeviewSelect)
        self._setcolorentry()
        
    def _setcolorentry(self):
        fs = self._entryfocused
        fd = self._found
        if fd:
            color = '#9FFFF0' if fs else '#E0FDF8'
        else:
            color = '#D3BBE9' if fs else '#EFE0FD'
        self.entrySearch.config(background =color )
        
    def event_TreeviewSelect(self,*e):
        #print dir(e)
        out = []
        selected = self.selection()
        if not selected:
            return
        id = selected[0]
        def getpathPage(id,navig,out):
            for x in navig:
                if id == x['id']:
                    out.append(x['name'])
                    #print x['name']
                    return 1
                else:
                    if getpathPage(id,x['child'],out):
                        out.append(x['name'])
                        return 1
                    
        getpathPage(id,self.navig,out)
        out.reverse()
        self._curentpath = out
        #print out
        if self.pageSelect:
            self.pageSelect(out)
        
    def updateTree(self):
    
        def ddel(dat):
            for x in dat:
                ddel(x['child'])
                self.delete(x['id'])            
        ddel( self.navig)
        self.pushData(self.data)
        
    def menuCalbak(self,foo):
        def call(*e):
            if foo:
                return foo(self._pathTomenu)
        return call
    
        
        
    def popupCreate(self,rename = None,
                    addchildpage=None,
                    deletepage = None):    
        self.popupMenu = Menu(self, tearoff=0,font ="Verdana 8 bold" )
        #self.popupMenu.add_separator()
        self.popupMenu.add_command(label="-----",state='disabled')
        self.popupMenu.add_command(label="rename", command=self.menuCalbak(rename))
        self.popupMenu.add_command(label="add page", command=self.menuCalbak(addchildpage ))
        self.popupMenu.add_command(label="delete page", command=self.menuCalbak(deletepage ))
        
        self.popupMenuEntry = Menu(self, tearoff=0,font ="Verdana 8 bold" )
        self.popupMenuEntry.add_command(label="cut",state='disabled')
        self.popupMenuEntry.add_command(label="copy",state='disabled')
        self.popupMenuEntry.add_command(label="paste",state='disabled')
        #self.entrySearch.bind("<ButtonRelease-3>", self._menuentrySearch)
        
        #self.bind("<ButtonRelease-3>", self._menu) 
    def _menuentrySearch(self):
        pass
        
    def _menu(self,event,path = None):
        event = event[0]
        self._pathTomenu = path
        try:
            if path:
                self.popupMenu.entryconfig(0, label=path)
            self.popupMenu.tk_popup(event.x_root, event.y_root, 0)
        except TclError, e:  
            print 'TclError:',e
        finally:
            self.popupMenu.grab_release()        
    
    
    def treCliker(self,name,id):
            def call(*e):
                self.focus(id)
                self.see(id)
                self.selection_set(id)
                self._menu(e,path =name)
                print name 
                #print dir(self) 
                
            return call
    
    def pushData(self,data):  
        '''navig = [ {'name':p,
                    'id':id,
                    'visible':1,
                    'child':[{'name':p,
                            'id':id,
                            'visible':1,
                            'child':
                            ]}
                    ]'''

            
        self.navig = []    
        self.data = data
        toplevelmodule = ['all']
        for p in sorted(data.keys()):
            tagname = p
            toplevelmodule.append(p)
            id = self.insert('', 'end', text=data[p]['caption'],tags=(tagname))
            self.tag_bind(tagname, '<3>', self.treCliker(tagname,id))
            self.navig.append({'name':p,'id':id,'child':[],'visible':1}) 
            #self.data
            
            self._rappend(id,data[p]['child'],self.navig[-1]['child'],tagname)
            #for p2 in data[p]['child']:
            #    id2 = self.insert(id, 'end', text=p2)
            #self.navig[p]=id
        self.searhModule['values'] =toplevelmodule
        self.searhModule.set(toplevelmodule[0])
    def _rappend(self,idparent,data,nav,tagname):
        for d in sorted(data.keys()):
            tag= tagname+'.'+d
            id = self.insert(idparent, 'end', text=data[d]['caption'],tags=(tag))
            self.tag_bind(tag, '<3>', self.treCliker(tag,id))
            nav.append({'name':d,'id':id,'child':[],'visible':1})
            #print data[d]
            self._rappend(id,data[d]['child'],nav[-1]['child'],tag)
    
    
    def _rsearch(self,txt,navig,inside = 0,data=None):
        
        #print '==='
        v = 0    
        for x in navig:
            #print x['name'],'start'
            if not txt or txt in x['name']:
                v = 1
                x['visible'] = 1
                self._found = 1
            else:
                #print "data[x]['lowertext']"
                #print  x['name']
                #print  data[x['name']]
                #print
                if self.inside and data and txt in data[x['name']]['lowertext']:
                    v = 1
                    x['visible'] = 1 
                    self._found = 1
                else:
                    x['visible'] = 0
            # print x['name'],'visible',x['visible']   
            z =  self._rsearch(txt,x['child'],inside,data=data[x['name']]['child'])  
            # print x['name'],'z',z    
            x['visible'] = z or x['visible']
            v =  z or x['visible'] or v
            
            #print x['name'],'x[visible] = v =  ',x['visible'] 
       # print navig,'return v',v
        return v 
        
    def _moveDeatt(self,paernId,navig):
        for x in navig: 
            if x['visible']:
                self.move(x['id'],paernId,'end')
                self.item(x['id'], open=1)
                self._moveDeatt(x['id'],x['child'])
            else:   
                self.detach(x['id'])
    
        
    def search(self,txt,inside = 0):
        self.inside =  self.check1var.get()
        self._found = 0
        if self.searhModuleSelected == 'all':
    
            self._rsearch(txt,self.navig,inside,data=self.data)
        else:
            for x in self.navig:
                if x['name'] == self.searhModuleSelected:
                    self._rsearch(txt,x['child'],inside,data=self.data[x['name']]['child'])
                    self.item(x['id'], open=1)
                    x['visible'] = 1
                    self._found = 1
                else:
   
                    x['visible'] = 0
                        
        
        # E5B0FC
        self._setcolorentry()     
            #import pprint
            #pprint.pprint(self.navig)
        
            
        self._moveDeatt('',self.navig)
        
    def getID(self,pagepath):
        xnav = self.navig
        for p in pagepath[:-1]:
            xnav = [x['child'] for x in xnav if  x['name'] == p][0]  
        xnav = [x for x in xnav if  x['name'] == pagepath[-1]][0]  
        #print  xnav   
        return xnav['id']
    
    def event_Entry_KeyRelease(self,event):
        if event and (event.keycode == 38 or 40 ==  event.keycode):
            self.focus_force()
            if not self.selection():
                for x in self.navig:
                    if x['visible']:
                        id = x['id']
                        self.selection_set(id)
                        self.focus(id)
                        self.see(id)
                        
            return
        text = unicode(self.entrySearch.get().strip().lower())
        self.search(text) 
        
    def event_ComboboxSelected(self,*event):
        self.searhModuleSelected = self.searhModule.get()
        self.event_Entry_KeyRelease(0)
        
    def event_tree_KeyRelease(self,event):
        #print event.keycode
        if event.keycode == 16 or event.keycode == 17:
            self.entrySearch.focus_force()
        
        s = event.char.lower()

        if s.isalpha():
            #print 'is alpha %s'%s
            #print  self._curentpath
            if self._curentpath:
                xnav = self.navig
                for p in  self._curentpath[:-1]:
                    xnav = [x['child'] for x in xnav if  x['name'] == p][0]
                
                for x in xnav:
                    if x['visible'] and x['name'].startswith(s):
                        id = x['id'] 
                        self.selection_set(id)
                        self.focus(id)
                        self.see(id)
                        self.selection_set(id)
                        self.focus(id)
                        self.see(id)
                        return            
        

        

def mainTest():
    import PageWidget
    import HtmlBBcodeParser
    PATH = '\\'.join((sys.argv[0].split('\\')[0:-1]))+'\\'
    root = Tk()
    
    leftFrame = Frame(root)
    leftFrame.pack(side= 'left',fill = "both",expand  = 1)

    rightFrame = Frame(root)
    rightFrame.pack(side= 'right',fill = "both",expand  = 1)
    
    tree = TreeWiget(leftFrame)
    
    
    data = {'es':
                {'caption':'module ES',
                'bbcode':'test [b]ES[/b] page [GO]es.tell[/GO]',
                #'myData':None # for fast rendering
                'lowertext':'test es page',  # for fast search  inside
                'child':{ 'msg':{'caption':'---msg',
                                'bbcode':'test [b]msg[/b] page [GO]es.tell[/GO]',
                                #'myData':None # for fast rendering
                                'lowertext':'test msg page',  # for fast search  inside
                                'child':{
                                'msg2':{'caption':'---msg2',
                                        'bbcode':'test [b]msg2[/b] page [GO]es.tell[/GO]',
                                        #'myData':None # for fast rendering
                                        'lowertext':'test msg2 page',  # for fast search  inside
                                        'child':{}}, 
                                        }
                                }, 
                        'tell':{'caption':'---tell',
                                'bbcode':'test [b]tell[/b] page [GO]es.msg[/GO]',
                                #'myData':None # for fast rendering
                                'lowertext':'test tell page',  # for fast search  inside
                                'child':{}},
                        }, 
                },        
                       
            'module_hz': {'caption':'module_hz',
                'bbcode':'test [b]module_hz[/b] page [url]google.ru[url]',
                #'myData':None # for fast rendering
                'lowertext':'test module_hz page',  # for fast search  inside
                'child':{}},       
                       
            }
    
    dd = {'bbcode':'test [b]module_hz dddd[/b] page [GO]es.tell[/GO] [GO]es.msg[/GO] [GO]es.msg.msg2[/GO] [GO]es.tellssss[/GO]',
                'caption':'module_hz',
                #'myData':None # for fast rendering
                'lowertext':'test module_hz  dddd',  # for fast search  inside
                'child':{}}
                
    import pprint
    from copy import deepcopy            
    data['module_hz']['child'] =  dict([(str(x),deepcopy(dd)) for x in range(10)])
    
    
    for cc in data['module_hz']['child']:
        z =  dict([(str(x),deepcopy(dd)) for x in range(20)])
        data['module_hz']['child'][cc]['child'] =z
        data['module_hz']['child'][cc]['caption'] = 'cc %s'%cc
        data['module_hz']['child'][cc]['bbcode'] += ' cc %s'%cc
        for bb in data['module_hz']['child'][cc]['child']:
            z1 =  dict([(str(x),deepcopy(dd)) for x in range(20)])
            data['module_hz']['child'][cc]['child'][bb]['child']  =  z1
        
    #pprint.pprint(data)     
    #raise
    
   
    import pickle,datetime
    #fname = bak = PATH+'data.db'
    #output = open(fname, 'wb')

    #pickle.dump(data, output)
    #output.close()
    
    
    tree.pushData(data)
    

    t = PageWidget.PageWidget(rightFrame, 
                    font = 12,
                    selectbackground ='#C8C8C8',
                    borderwidth  = 3,
                    #height  = 3,
                    cursor = 'arrow',
                    wrap = "none")
                    
    t.path = PATH
    t.popupCreate()
    
    def pageSelect(pagepath):
        try:
            xdata = data 
            for key in pagepath[:-1]:
                xdata = xdata[key.lower()]['child']
            page = xdata[pagepath[-1].lower()] 
            t.putBBCODE(page['bbcode'])
        except:
            link = '.'.join(pagepath)
            bb = '[b][SIZE=15][COLOR="Red"]Error[/COLOR][/SIZE]\n %s[/b] bad link'% link   
            t.putBBCODE(bb)
    tree.pageSelect = pageSelect
    
    def link(url):
        z = url.split('://',1)
        if z[0] == 'go':
            pageSelect(z[1].split('.'))
        
        else:
            print url,'internet'
    t.linkcommand = link
    print sys.argv[0]
    exampletext = u'''test page  [go]es.msg[/go]
    
        [COLOR="Red"][SIZE="25"]17 [i]сло[/i]жные     [B]
        вложеные [SIZE="5"] теги5 [/SIZE] [/B] 
        [s]red17[/s]  [COLOR="Blue"][u]здесь[/u] bl 17[/COLOR]
        red 17[/SIZE]norm red[/COLOR]
[code]%s[/code]'''%open(sys.argv[0]).read().decode('utf8')
    
    t.putBBCODE(exampletext)
    
    root.mainloop()
    
if __name__ == '__main__':  
    mainTest()
